/* the main AgentCore core code : finds out what is being called, 
 * does a little sanity check, and passes control to the function 
 * responsible for handling the major branch 
 *  - omer 3.28 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "lib/oids_supported.h" /*takes care of including snmpdh_types.h*/


void	AgentCore(short int req_type, 
		const oid *req_oid, 
		const int oid_length,
		char *set_value, 
		oid_datatype_value *oid_and_data)	
{
	char data[128];
	int data_int;
	oid next_oid[20]; /*(as u_long = 4B)*/
	//oid next_oid[(sizeof(req_oid))/4]; /*(as u_long = 4B)*/
	int flag_out_of_subtree=0;

	//printf("[AgentCore] req_type: %d, len: %d, set: %s\n", req_type, oid_length, set_value);
	/*printf("[AgentCore] reqoid rcvd: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d\n", 
	  req_oid[0], req_oid[1], req_oid[2], req_oid[3],
	  req_oid[4], req_oid[5], req_oid[6], req_oid[7],
	  req_oid[8], req_oid[9], req_oid[10], req_oid[11],
	  req_oid[12], req_oid[13], req_oid[14], req_oid[15]);  */

	switch (*(req_oid+6))	{
		case 1:
			SystemFn (req_type, req_oid, oid_length, data, next_oid, set_value);
			data_int = atoi(data);	
			if (data_int == -2)	{ //snmpgetnext on last system oid
				bzero(data,sizeof(data));
				IpFn(1, c_ipNetToMediaIfIndex, sizeof(c_ipNetToMediaIfIndex), 
						data, next_oid, set_value);
				NullNextOid(oid_and_data->requested_oid);
				memcpy(oid_and_data->requested_oid, next_oid, 
						sizeof(next_oid));
				strcpy(oid_and_data->value, data);
			} else {
				memcpy(oid_and_data->requested_oid, next_oid, sizeof(next_oid));
				strcpy(oid_and_data->value, data);
				//	OidAndDataPrinter("AgentCore", oid_and_data);

			}
			break;
		case 4:
			IpFn (req_type, req_oid, oid_length, data, next_oid, set_value);
			//printf("AgentCore: data %s\n",data);
			data_int = atoi(data);	
			if (data_int == -2)	{
				bzero(data,sizeof(data));
				//printf("[AgentCore] ip tree walked..onto icmptree\n");
				IcmpFn(0, c_icmpInEchos0 ,oid_length, data, next_oid);
				/* here we do an snmpget request to icmpfn, to get the 
				 * value for c_icmpInEchos0 */
				NullNextOid(oid_and_data->requested_oid);
				memcpy(oid_and_data->requested_oid,c_icmpInEchos0, sizeof(c_icmpInEchos0));
				strcpy(oid_and_data->value, data);
				/* and we massage the oid received back to be c_icmpInEchos0 */
			} else {
				memcpy(oid_and_data->requested_oid, next_oid, sizeof(next_oid));
				/* 60 = 20x(4B for u_long) */
				strcpy(oid_and_data->value, data);
			}
			break;
		case 5:
			IcmpFn (req_type, req_oid, oid_length, data, next_oid);
			data_int = atoi(data);	
			if (data_int == -2)	{
				bzero(data,sizeof(data));
				//printf("[AgentCore] icmp tree walked..onto tcptree\n");
				TcpFn (req_type,c_tcpConnState ,sizeof(c_tcpConnState), data, next_oid);
				memcpy(oid_and_data->requested_oid,next_oid, sizeof(next_oid));
				strcpy(oid_and_data->value, data);
			} else {
				memcpy(oid_and_data->requested_oid, next_oid, sizeof(next_oid));
				strcpy(oid_and_data->value, data);
			}
			break;
		case 6:
			TcpFn (req_type, req_oid, oid_length, data, next_oid);
			data_int = atoi(data);	
			if (data_int == -2)	{
				//printf("[AgentCore: whole tree walked!]\n");
				NullNextOid(oid_and_data->requested_oid);
				memcpy(oid_and_data->requested_oid, req_oid, oid_length);
				strcpy(oid_and_data->value, data);
				return;
				/*the whole mib has been walked.*/
			} else
			{
				memcpy(oid_and_data->requested_oid, next_oid, sizeof(next_oid));
				strcpy(oid_and_data->value, data);
			}

			break;
		default:

			if (req_type != SNMPGETNEXT)
			{
				sprintf(oid_and_data->value,"%d", -1);
				memcpy(oid_and_data->requested_oid,req_oid, oid_length);
				break;
			}
			else
			{
				bzero(data,sizeof(data));
				//printf("[AgentCore] oid less than minimum supported size\n");
				strcpy(oid_and_data->value, data);
				SystemFn (	req_type, c_sysDescr, sizeof(c_sysDescr), 
						data, next_oid, set_value);
				/*this is less than the actual length, so systemfn can 
				 * take care of it */
				{
					memcpy(oid_and_data->requested_oid, next_oid, sizeof(next_oid));
					strcpy(oid_and_data->value, data);
				}
			}
			break;
	}
}


//	if (*data == -1)
// this means someone
// (a) tried to set a RO variable or 
// (b) tried to set a valid length OID who's instance
// does not exist

/*printf("[AgentCore] NextOId: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d\n", 
  next_oid[0], next_oid[1], next_oid[2], next_oid[3],
  next_oid[4], next_oid[5], next_oid[6], next_oid[7],
  next_oid[8], next_oid[9], next_oid[10], next_oid[11],
  next_oid[12], next_oid[13], next_oid[14], next_oid[15]);  */

int GetNextTest(const oid *startoid, int oid_len)
{
	short int req_type = 1;
	char set_val = 0;
	const char test_data[] = "-2";
	oid_datatype_value o_and_d;

	//printf("[GetNextTest.]oid_len %d\n", oid_len);
	AgentCore(req_type, startoid, oid_len, &set_val, &o_and_d);

	/*printf("[GetNext WhatWeGotFromClient] rcvd: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d: \n", 
	  startoid[0], startoid[1], 
	  startoid[2], startoid[3],
	  startoid[4], startoid[5], 
	  startoid[6], startoid[7],
	  startoid[8], startoid[9],
	  startoid[10], startoid[11], 
	  startoid[12], startoid[13],
	  startoid[14], startoid[15],
	  startoid[16], startoid[17],
	  startoid[18], startoid[19]); */

	//while (o_and_d.requested_oid[6] == 6)
	while (strcmp(o_and_d.value, test_data) != 0)
	{

		/*printf("[GetNextTest] rcvd: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d: ", 
		  o_and_d.requested_oid[0], o_and_d.requested_oid[1], 
		  o_and_d.requested_oid[2], o_and_d.requested_oid[3],
		  o_and_d.requested_oid[4], o_and_d.requested_oid[5], 
		  o_and_d.requested_oid[6], o_and_d.requested_oid[7],
		  o_and_d.requested_oid[8], o_and_d.requested_oid[9],
		  o_and_d.requested_oid[10], o_and_d.requested_oid[11], 
		  o_and_d.requested_oid[12], o_and_d.requested_oid[13],
		  o_and_d.requested_oid[14], o_and_d.requested_oid[15],
		  o_and_d.requested_oid[16], o_and_d.requested_oid[17],
		  o_and_d.requested_oid[18], o_and_d.requested_oid[19]);

		  printf(" %s\n", o_and_d.value); */

		AgentCore(req_type, o_and_d.requested_oid, sizeof(o_and_d.requested_oid),
				&set_val, &o_and_d);

	}
	1;
}


