/* error message creator */
#include <stdio.h>
#include <string.h>
#include "lib/oids_supported.h" /*takes care of including snmpd_types.h*/


int EInt2CharOID(const oid *int_oid,char *char_OID)
{
	/* note: the non valid oid branches would be marked as -1*/
	int i, oid_length;
	char c_tmp[10];
	strcat(char_OID, ".");
	for (i=0; i<20; i++)
	{
		if (int_oid[i] != -1)
		{
			sprintf(c_tmp, "%d.", int_oid[i]);
			strcat(char_OID, c_tmp);
		} else
		{
			if (char_OID[strlen(char_OID)-1] == '.')
				char_OID[strlen(char_OID)-1] = '\0';
			printf("[CreateErrorMessage] final string:%sEND\n", char_OID);
			return(i);
		}
	}
	if (char_OID[strlen(char_OID)-1] == '.')
		char_OID[strlen(char_OID)-1] = '\0';
	return(i);
}

int CreateErrorMessage (const decoded_packet_struct *decoded_request,
		checked_query_result *qsn_output,
		packet_to_be_encoded *response)
{
	char char_OID[200];
	//DpsPrinter("CreateErrorMessage", decoded_request);
	//CqrPrinter("CreateErrorMessage", qsn_output);

	//	P2bEPrinter("CreateErrorMessageBEF", response);
	/*version, community, pdu_type*/
	response->version = decoded_request->version;
	strcpy(response->community, decoded_request->community);
	response->pdu_type = decoded_request->pdu_type;
	response->request_id = decoded_request->request_id;

	/*error info*/
	response->error_status = qsn_output->error_status;
	response->error_index = 0; /*singleOID in pkt supported*/

	/*OID*/
	bzero(response->Oid, sizeof(response->Oid));
	bzero(char_OID, sizeof(char_OID));
	EInt2CharOID(qsn_output->requested_oid, char_OID);
	//EInt2CharOID(decoded_request->OID, char_OID);
	memcpy(response->Oid, char_OID, strlen(char_OID));

	/*resp*/	
	bzero(response->Value, sizeof(response->Value));
	strncpy(response->Value, decoded_request->snmpset_value, sizeof(response->Value));
	//P2bEPrinter("CreateErrorMessageAFTER", response);
	return(1);
}

/*
   int main()	{ 
   char char_OID[60];
   oid testoid[] = {1,3,6,1,2,1,4,22,1, 4,1,192,168,1,1, -1,-1,-1,-1,-1};
   int oid_length;

   bzero(char_OID, sizeof(char_OID));
   oid_length = EInt2CharOID(testoid, char_OID);

   printf("main() : oid_string: %s, length %d\n", char_OID, oid_length);

   1;
   }
   */
