/* a collection of functions used to debug the software */
#include <stdio.h>
#include <string.h>
#include "lib/oids_supported.h" /*takes care of including snmpd_types.h*/

int DpsPrinter(char *fn_name,const decoded_packet_struct *dps) {

	printf("[%s] Decoded Fields: version:%d, commstr:%s, pdutype:%d, reqid:%d, err:%d, setval:%s\n",
			fn_name, dps->version, dps->community, dps->pdu_type, dps->request_id, dps->error_status, dps->snmpset_value);

	printf("[%s] Decoded OID: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d\n", 
			fn_name,		dps->OID[0], dps->OID[1], 
			dps->OID[2], dps->OID[3],
			dps->OID[4], dps->OID[5], 
			dps->OID[6], dps->OID[7],
			dps->OID[8], dps->OID[9],
			dps->OID[10], dps->OID[11], 
			dps->OID[12], dps->OID[13],
			dps->OID[14], dps->OID[15],
			dps->OID[16], dps->OID[17],
			dps->OID[18], dps->OID[19]);
	1;
}

int OidAndDataPrinter(char *fn_name, const oid_datatype_value *o_and_d)
{
	printf("[%s] AgentCore Output: (OID: data): %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d: ", 
			fn_name, o_and_d->requested_oid[0], o_and_d->requested_oid[1], 
			o_and_d->requested_oid[2], o_and_d->requested_oid[3],
			o_and_d->requested_oid[4], o_and_d->requested_oid[5], 
			o_and_d->requested_oid[6], o_and_d->requested_oid[7],
			o_and_d->requested_oid[8], o_and_d->requested_oid[9],
			o_and_d->requested_oid[10], o_and_d->requested_oid[11], 
			o_and_d->requested_oid[12], o_and_d->requested_oid[13],
			o_and_d->requested_oid[14], o_and_d->requested_oid[15],
			o_and_d->requested_oid[16], o_and_d->requested_oid[17],
			o_and_d->requested_oid[18], o_and_d->requested_oid[19]);

	printf(" %s\n", o_and_d->value);
	1;
}

int CqrPrinter(char *fn_name, const checked_query_result *cqr)
{
	printf("[%s] CheckedQueryResult: error_status: %d request_id: %d request_type: %d snmpset_value: %s oid_length: %d\n",
			fn_name,	cqr->error_status, cqr->request_id, cqr->request_type, 
			cqr->snmpset_value, cqr->oid_length);
	//cqr.error_status, cqr.request_id, cqr.request_type, 
	//cqr.snmpset_value, cqr.oid_length);
	printf("[%s] CheckedQueryResult: Oid: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d\n", 
			fn_name,	cqr->requested_oid[0], cqr->requested_oid[1], 
			cqr->requested_oid[2], cqr->requested_oid[3],
			cqr->requested_oid[4], cqr->requested_oid[5], 
			cqr->requested_oid[6], cqr->requested_oid[7],
			cqr->requested_oid[8], cqr->requested_oid[9],
			cqr->requested_oid[10], cqr->requested_oid[11], 
			cqr->requested_oid[12], cqr->requested_oid[13],
			cqr->requested_oid[14], cqr->requested_oid[15],
			cqr->requested_oid[16], cqr->requested_oid[17],
			cqr->requested_oid[18], cqr->requested_oid[19]);
	1;
}

int P2bEPrinter(char *fn_name, const packet_to_be_encoded *p2be)
{
	printf("[%s] QueryResponse: version:%d commstr:%s req_type:%d, reqid:%d err:%d\n",
			fn_name, p2be->version, p2be->community, p2be->pdu_type,
			p2be->request_id, p2be->error_status);
	printf("[%s] QueryResponse: ResponseOID:%s, Data:%s\n", fn_name, p2be->Oid, p2be->Value);
	1;
}

