/* file handling ICMP branch of snmp tree */
/*OutEchos BROKEN IN LINUX KERNEL 2.4.17: does not increment */
#include <string.h>
#include <stdio.h>

#include "lib/oids_supported.h"

void OidCopier(oid *targetoid, const oid *sourceoid, const int src_oid_length)	
{
	memcpy(targetoid,sourceoid, src_oid_length);
	return;
}
void IcmpFn (short int req_type, const oid *req_oid, const int oid_length, char *data,oid *next_oid) 
	/* remember that for IcmpFn() we are always handed a safe OID
	 * so we dont have to check for its validity */
{
	bzero(data, sizeof(data));
	if (req_type == 3) //snmpset request! nanaa!
	{
		sprintf(data, "%d", -1);
		return;
	} 


	else if (req_type == 0) //snmpget request.
	{
		char line [128];
		int x1, x2, x3, x4 , x5, x6 , x7, x8 ,x9, x10, x11, x12, x13, x14,
		x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27;

		FILE *in = fopen ("/proc/net/snmp", "r");

		/*printf("[IcmpFn] req_oid[6] %d and req_oid[7] is %d\n", 
		 *(req_oid+6), *(req_oid+7)); */

		NullNextOid(next_oid);
		OidCopier(next_oid, req_oid, oid_length);/*return the same oid in next_oid*/

		/*printf("[IcmpFn] nextoid: %d.%d.%d.%d.%d.%d.%d\n", 
		  next_oid[0], next_oid[1], next_oid[2], next_oid[3],
		  next_oid[4], next_oid[5], next_oid[6], next_oid[7]); */

		while ((line == fgets(line, sizeof(line), in)) &&
				27 != sscanf (line, "Icmp: %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
					&x1, &x2, &x3, &x4 , &x5, &x6 , &x7, &x8 ,&x9, 
					&x10, &x11, &x12, &x13, &x14, &x15, &x16, &x17, &x18, 
					&x19, &x20, &x21, &x22, &x23, &x24, &x25, &x26, &x27))
		{
			continue;
		}



		switch (*(req_oid+7)) {

			case 8: //InEchos
				sprintf(data, "%d", x8);
				fclose (in);
				break;

			case 9: //InEchoReps
				sprintf(data, "%d", x9);
				fclose (in);
				break;

			case 21: //OutEchos
				sprintf(data, "%d", x21);
				fclose (in);
				break;

			case 22: //OutEchoReps
				sprintf(data, "%d", x22);
				fclose (in);
				break;

			default:
				//		printf("IcmpFn: error oid not supported\n");
				sprintf(data, "%d", -1);
				fclose (in);

				break;

		}

	}

	else if (req_type == 1) //snmpgetnext request
	{
		//this is always the whole OID as received from QSN

		char line [128];
		int x1, x2, x3, x4 , x5, x6 , x7, x8 ,x9, x10, x11, x12, x13, x14,
		x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25, x26, x27;

		FILE *in = fopen ("/proc/net/snmp", "r");

		while ((line == fgets(line, sizeof(line), in)) &&
				27 != sscanf (line, "Icmp: %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
					&x1, &x2, &x3, &x4 , &x5, &x6 , &x7, &x8 ,&x9, 
					&x10, &x11, &x12, &x13, &x14, &x15, &x16, &x17, &x18, 
					&x19, &x20, &x21, &x22, &x23, &x24, &x25, &x26, &x27))
		{
			continue;
		}


		switch (*(req_oid+7)) {

			case 8: //InEchos, return next value
				sprintf(data, "%d", x9);
				fclose (in);
				NullNextOid(next_oid);
				OidCopier(next_oid, c_icmpInEchoReps0, sizeof(c_icmpInEchoReps0));
				/*return the next oid in tree*/
				break;

			case 9: //InEchoReps, return next value
				sprintf(data, "%d", x21);
				fclose (in);
				NullNextOid(next_oid);
				OidCopier(next_oid, c_icmpOutEchos0, sizeof(c_icmpOutEchos0));
				/*return the next oid in tree*/
				break;

			case 21: //OutEchos, return next value
				sprintf(data, "%d", x22);
				fclose (in);
				NullNextOid(next_oid);
				OidCopier(next_oid, c_icmpOutEchoReps0, sizeof(c_icmpOutEchoReps0));
				/*return the next oid in tree*/
				break;

			case 22: //OutEchoReps, return next value
				sprintf(data, "%d", -2);
				fclose (in);
				//sending back -2 to tell agent_core that this table
				//has been totally walked...
				//also note, that next_oid would be computed by agent_core in this case
				break;

			default:
				/*small oid rcvd, return first 5.8.0 oid and data*/
				sprintf(data, "%d", x8);
				fclose (in);
				NullNextOid(next_oid);
				OidCopier(next_oid, c_icmpInEchos0, sizeof(c_icmpInEchos0));
				break;

		}
		/*
		   printf("[IcmpFn] nextoid: %d.%d.%d.%d.%d.%d.%d\n", 
		   next_oid[0], next_oid[1], next_oid[2], next_oid[3],
		   next_oid[4], next_oid[5], next_oid[6], next_oid[7],
		   next_oid[8], next_oid[9]);
		   */
	}

}
