/* this header file has a list of all the fixed portions of the i              * supported OIDs: would be used by query_sanity_checker to verify incoming
 * oid request */

#ifndef _OID_SUP
#define _OID_SUP 1

#include "snmpd_types.h"
static const oid c_sysDescr[] = {1, 3, 6, 1, 2, 1, 1, 1};
static const oid c_sysDescr0[] = {1, 3, 6, 1, 2, 1, 1, 1, 0};
static const oid c_sysObjectID0[] = {1, 3, 6, 1, 2, 1, 1, 2, 0};
static const oid c_sysUpTime0[] = {1, 3, 6, 1, 2, 1, 1, 3, 0};
static const oid c_sysContact0[] = {1, 3, 6, 1, 2, 1, 1, 4, 0};
static const oid c_sysName0[] = {1, 3, 6, 1, 2, 1, 1, 5, 0};
static const oid c_sysLocation0[] = {1, 3, 6, 1, 2, 1, 1, 6, 0};
static const oid c_sysServices0[] = {1, 3, 6, 1, 2, 1, 1, 7, 0};

// note how we have included the instance 0 in the constant part of the oid 
// this way query_sanity_checker would throw an error msg by verifying the 
// oid and not sending something like .1.3.6.1.2.1.1.1.10 to agent_core 

static const oid c_ipNetToMediaIfIndex[] = {1,3,6,1,2,1,4,22,1,1};
static const oid c_ipNetToMediaPhysAddress[] = {1, 3, 6, 1, 2, 1, 4, 22, 1, 2};
static const oid c_ipNetToMediaNetAddress[] = {1, 3, 6, 1, 2, 1, 4, 22, 1, 3};
static const oid c_ipNetToMediaType[] = {1, 3, 6, 1, 2, 1, 4, 22, 1, 4};

static const oid c_icmpInEchos0[] = {1,3,6,1,2,1,5,8,0};
static const oid c_icmpInEchoReps0[] = {1,3,6,1,2,1,5,9,0};
static const oid c_icmpOutEchos0[] = {1,3,6,1,2,1,5,21,0};
static const oid c_icmpOutEchoReps0[] = {1,3,6,1,2,1,5,22,0};

/*
//note how we are checking the FULL oid for the icmp table above also, similar to the system table above 
*/
static const oid c_tcpConnState[] = {1,3,6,1,2,1,6,13,1,1};
static const oid c_tcpConnLocalAddress[] = {1,3,6,1,2,1,6,13,1,2};
static const oid c_tcpConnLocalPort[] = {1,3,6,1,2,1,6,13,1,3};
static const oid c_tcpConnRemAddress[] = {1,3, 6, 1, 2, 1, 6, 13, 1, 4};
static const oid c_tcpConnRemPort[] = {1, 3, 6, 1, 2, 1, 6, 13, 1, 5};
/*

// Below we define the datatypes for each of the supported OIDs. This is 
// to help the ber_encoder in encoding the values
const char dt_sysDescr0[] = "DisplayString"
const char dt_sysObjectID0[] = "OBJECT ID";
const char dt_sysUpTime0[] = "Timeticks";
const char dt_sysContact0[] = "DisplayString";
const char dt_sysName0[] = "DisplayString";
const char dt_sysLocation0[] = "DisplayString";
const char dt_sysServices0[] = "Integer";

const char dt_ipNetToMediaIfIndex[] = "Integer";
const char dt_ipNetToMediaPhysAddress[] = "PhysAddress";
const char dt_ipNetToMediaNetAddress[] = "IpAddress";
const char dt_ipNetToMediaType[] = "Integer";

const char dt_icmpInEchos0[] = "Counter";
const char dt_icmpInEchoReps[] = "Counter";
const char dt_icmpOutEchos[] = "Counter";
const char dt_icmpOutEchoReps[] = "Counter";


const char dt_tcpConnState[] = "Integer";
const char dt_tcpConnLocalAddress[] = "IpAddress";
const char dt_tcpConnLocalPort[] = "Integer";
const char dt_tcpConnRemAddress[] = "IpAddress";
const char dt_tcpConnRemPort[] = "Integer";

*/
#endif
