/*takes in ascii request, and populates the output in the form of
 * struct decoded_packet_struct */
#include <stdio.h>
#include "lib/oids_supported.h"
#include <string.h>
#include <stdlib.h>

int RequestDecoder(const char *req, decoded_packet_struct *dps)
{
	oid *int_oid[20];
	int req_type, req_id;
	char req_cs[32];
	char req_charoid[250];
	char req_set_val[128];
	int errur;

	bzero(req_charoid, sizeof(req_charoid));
	if (5 != sscanf(req, "%d %s %s %s %d", 
				&req_type, req_cs, req_charoid, req_set_val, &req_id))
	{
		printf("incorrect request\n");
		return(-1);
	}


	switch (req_type)
	{
		case SNMPGET: case SNMPGETNEXT: case SNMPSET:
			if ((errur = Char2IntOID(req_charoid, int_oid)) < 0)
			{
				PopulateDPS(req_cs, req_type, req_id, ERR_NOSUCHNAME, req_set_val, dps);
				memcpy(dps->OID, int_oid, sizeof(dps->OID));
			} else
			{
				PopulateDPS(req_cs, req_type, req_id, 0, req_set_val, dps);
				/*printf("printOId: %d\n", errur); */

				memcpy(dps->OID, int_oid, sizeof(dps->OID));
			}

			break;


		default:
			/*bad request*/
			Char2IntOID(req_charoid, int_oid); 
			PopulateDPS(req_cs, req_type, req_id, ERR_NOSUCHNAME, req_set_val, dps);
			memcpy(dps->OID, int_oid, sizeof(dps->OID));

			break;
	}/*end of switch*/

	1;
}


int Char2IntOID(char *char_oid, oid*int_oid)   {
	char temp_oid[5];    
	int char_counter = 0;
	int int_counter  = 0;

	bzero(temp_oid,sizeof(temp_oid));
	for (int_counter=0; int_counter < 20; int_counter++)   {
		int_oid[int_counter] = -1;
	}

	int_counter  = 0;

	while(char_oid[char_counter] != '\0')   {
		if (char_oid[char_counter] == '.')   {  

			char_counter++;
		}
		else   {

			while(char_oid[char_counter] != '.')   {
				if (char_oid[char_counter] == '\0')
					break;
				strncat(temp_oid, &char_oid[char_counter], 1);
				char_counter++;
			}
			if (int_counter == 20)
				return -1;
			int_oid[int_counter] = atoi(temp_oid);
			int_counter++;
			bzero(temp_oid, sizeof(temp_oid));
		}

	}       
	return (int_counter+1);
}

int RNullNextOid(oid *next_oid)	{
	/*this function initializes all values in the next_oid array*/
	int i;
	for (i=6;i<20;i++)	
		next_oid[i] = -1;
	/* making all -1 */
	1;
}

int PopulateDPS( /*not passing version*/
		char *req_cs, 
		int req_type,
		int req_id, 
		int error_status,
		/*not passing oid */
		char *req_set_val, 
		decoded_packet_struct *dps)
{
	dps->version = 0;
	strncpy(dps->community, req_cs, sizeof(dps->community));
	dps->pdu_type = req_type;
	dps->request_id = req_id;
	dps->error_status = error_status;
	strncpy(dps->snmpset_value, req_set_val, sizeof(dps->snmpset_value));
	1;
}

/*	
	int main() {
	decoded_packet_struct dps;
	char req[]="1 public .1.3.6.1.2.1.6.13.1.5.14.13.12.11.1234 -1 1234";

	RequestDecoder(req, &dps);

	printf("v:%d, c:%s, pdutype:%d, rqid:%d, err:%d, setval:%s\n",
	dps.version, dps.community, dps.pdu_type, dps.request_id, dps.error_status,
	dps.snmpset_value);

	printf("rcvd: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d: \n", 
	dps.OID[0], dps.OID[1], 
	dps.OID[2], dps.OID[3],
	dps.OID[4], dps.OID[5], 
	dps.OID[6], dps.OID[7],
	dps.OID[8], dps.OID[9],
	dps.OID[10], dps.OID[11], 
	dps.OID[12], dps.OID[13],
	dps.OID[14], dps.OID[15],
	dps.OID[16], dps.OID[17],
	dps.OID[18], dps.OID[19]);
	1;
	}
	*/
