/* file handling TCP branch of snmp tree */
#include <string.h>
#include <stdio.h>
#include "lib/snmpd_types.h"

tcp_table *tcpConnTable_LL;

void TcpFn (short int req_type, const oid *req_oid, const int oid_length, 
		char *data, oid *next_oid) 
{
	/*printf("[TcpFn] 1reqoid rcvd: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d\n", 
	  req_oid[0], req_oid[1], req_oid[2], req_oid[3],
	  req_oid[4], req_oid[5], req_oid[6], req_oid[7],
	  req_oid[8], req_oid[9], req_oid[10], req_oid[11],
	  req_oid[12] , req_oid[13], req_oid[14], req_oid[15]); */

	if (req_type == 0) //snmpget
	{
		//snmpget for TcpFn always gets right length of query from
		//query sanity checker: thus no need to check size
		FILE *in;
		char line[300];
		/* .1.3.6.1.2.1.6.13.1.1.A.B.C.D.X.P.Q.R.S.Y  */
		int A,B,C,D,X,P,Q,R,S,Y,tcpstate;
		int leaf_matched = 0;

		bzero(data, sizeof(data));
		/*below two are defined in ipfn.c */
		NullNextOid(next_oid); 
		OidCopier(next_oid, req_oid, oid_length);/*return the same oid in next_oid*/

		//		printf("oid length %d\n", oid_length);

		if (! (in = fopen("/proc/net/tcp", "r")))
		{
			perror("TcpFn: cannot open /proc/net/tcp..");
			return;
		}


		while ((line == fgets (line, sizeof(line), in)) && (!leaf_matched))
		{

			if (11 != sscanf (line,
						"%*d: %2x%2x%2x%2x:%x %2x%2x%2x%2x:%x %x %*X:%*X %*X:%*X %*X %*d",
						&D, &C, &B, &A, &X, &S,&R, &Q, &P , &Y, &tcpstate))
				continue; 


			printf("[tcpfn] scanned: %d.%d.%d.%d:%d -> %d.%d.%d.%d:%d\n", A,B,C,D,X,P,Q,R,S,Y);
			printf("[tcpfn] rcvd: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d: ", 
					req_oid[0], req_oid[1], 
					req_oid[2], req_oid[3],
					req_oid[4], req_oid[5], 
					req_oid[6], req_oid[7],
					req_oid[8], req_oid[9],
					req_oid[10], req_oid[11], 
					req_oid[12], req_oid[13],
					req_oid[14], req_oid[15],
					req_oid[16], req_oid[17],
					req_oid[18], req_oid[19]);

			if ((req_oid[10] == A) && (req_oid[11] == B) && (req_oid[12] == C)
					&& (req_oid[13] == D) && (req_oid[14] == X) && (req_oid[15] == P)
					&& (req_oid[16] == Q) && (req_oid[17] == R) && (req_oid[18] == S)
					&& (req_oid[19] == Y))
				leaf_matched++;

		}		


		if (leaf_matched)	{
			switch (*(req_oid+9)) {

				case 1: /*tcpConnState.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d", Proc2Snmp(tcpstate));
					/*printf("TcpFn: tcpConnState matched!");
					  switch (tcpstate)
					  {
					  case PROC_TCP_ESTABLISHED:
					  sprintf(data, "%d", SNMP_TCP_ESTABLISHED);
					  break;
					  case PROC_TCP_SYN_SENT:
					  sprintf(data, "%d", SNMP_TCP_SYN_SENT);
					  break;
					  case PROC_TCP_SYN_RECV:
					  sprintf(data, "%d", SNMP_TCP_SYN_RECV);
					  break;
					  case PROC_TCP_FIN_WAIT1:
					  sprintf(data, "%d", SNMP_TCP_FIN_WAIT1);
					  break;
					  case PROC_TCP_FIN_WAIT2:
					  sprintf(data, "%d", SNMP_TCP_FIN_WAIT2);
					  break;
					  case PROC_TCP_TIME_WAIT:
					  sprintf(data, "%d", SNMP_TCP_TIME_WAIT);
					  break;
					  case PROC_TCP_CLOSE:
					  sprintf(data, "%d", SNMP_TCP_CLOSE);
					  break;
					  case PROC_TCP_CLOSE_WAIT:
					  sprintf(data, "%d", SNMP_TCP_CLOSE_WAIT);
					  break;
					  case PROC_TCP_LAST_ACK:
					  sprintf(data, "%d", SNMP_TCP_LAST_ACK);
					  break;
					  case PROC_TCP_LISTEN:
					  sprintf(data, "%d", SNMP_TCP_LISTEN);
					  break;
					  case PROC_TCP_CLOSING:
					  sprintf(data, "%d", SNMP_TCP_CLOSING);
					  break;
					  } /*end of switch(tcpstate)*/
					fclose (in);
					break;

				case 2: /*tcpConnLocalAddress.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d.%d.%d.%d",
							A,B,C,D);
					fclose (in);
					break;

				case 3: /*tcpConnLocalPort.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d", X);
					fclose (in);
					break;

				case 4: /*tcpConnRemAddress.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d.%d.%d.%d",
							P,Q,R,S);
					fclose (in);
					break;


				case 5: /*tcpConnRemPort.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d", Y);
					fclose (in);
					break;

				default:
					//error: oid not supported\n");
					sprintf(data, "%d", -1);
					fclose (in);
					break;

			}/*end of switch(reqoid[9])*/


		} else {
			/* if leaf_match != 0, then its an oopsy!*/
			printf("leaf didnt match\n");
			sprintf(data, "%d", -1);
			fclose (in);
			return;
		}

	} /*end if req_type ==0 */

	/* -------SNMPGETNEXT CODING FOR TCP --------*/

	else if (req_type == 1) //snmpgetnext
	{

		int A,B,C,D,X,P,Q,R,S,Y,tcpstate;
		char line[300];
		FILE *in;


		if (! (in = fopen("/proc/net/tcp", "r")))
		{
			perror("TcpFn: cannot open /proc/net/tcp..");
			return;
		}

		/* note: we might get an OID of variable length. from
		   .1.3.6.1.2.1.4.22.1.[1-4] [10 levels]
		   .1.3.6.1.2.1.4.22.1.[1-4].X.A.B.C.D [15 levels] */

		bzero(data, sizeof(data));


		if (oid_length < 80) /*remember u_long = 4bytes, and oid_length = 20*4bytes*/
		{
			/*this means that the oid QSN has given us  till:
			  .1.3.6.1.2.1.6.13.1.[1-4]
			  thus we'll grab the first line in /proc/net/tcp,
			  and filter out the request once we have it. */

			while ((line == fgets(line, sizeof(line), in)) &&
					(11 != sscanf (line,
								   "%*d: %2x%2x%2x%2x:%x %2x%2x%2x%2x:%x %x %*X:%*X %*X:%*X %*X %*d",
								   &D, &C, &B, &A, &X, &S,&R, &Q, &P , &Y, &tcpstate)))
			{
				continue; 
			}

			/*first, let's copy over whatever the req_oid is over our next_oid[20]
			 * we will build the oid after this */
			NullNextOid(next_oid);
			OidCopier(next_oid, req_oid, oid_length);
			InitNextOid(next_oid); /*ensuring the first 6 constt values are there*/
			/*you never know what the client sent for a get next request! */

			/*now plastering everything else (but F) in the OID: 
			 * .1.3.6.1.2.1.6.13.1.F.A.B.C.D.X.P.Q.R.S.Y
note: we still dont know F in the above oid, infact we dont know if we 
have even received that or not...*/
			next_oid[6] = 6;
			next_oid[7] = 13;
			next_oid[8] = 1;
			next_oid[10] = A; //ifIndex;
			next_oid[11] = B;
			next_oid[12] = C;
			next_oid[13] = D;
			next_oid[14] = X;
			next_oid[15] = P;
			next_oid[16] = Q;
			next_oid[17] = R;
			next_oid[18] = S;
			next_oid[19] = Y;


			/*all's left is next_oid[9]...if the following checks out, next_oid is good!*/

			switch (*(req_oid+9)) {

				case 1: /*tcpConnState.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d", Proc2Snmp(tcpstate));
					fclose (in);
					break;

				case 2: /*tcpConnLocalAddress.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d.%d.%d.%d",
							A,B,C,D);
					fclose (in);
					break;

				case 3: /*tcpConnLocalPort.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d", X);
					fclose (in);
					break;

				case 4: /*tcpConnRemAddress.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d.%d.%d.%d",
							P,Q,R,S);
					fclose (in);
					break;


				case 5: /*tcpConnRemPort.A.B.C.D.X.P.Q.R.S.Y*/
					sprintf(data, "%d", Y);
					fclose (in);
					break;

				default:
					/* this means the client did not send this info
					   thus, we'll respond with the first oid in the table.
					   that is tcpConnState*/
					next_oid[9] = 1;
					sprintf(data, "%d", Proc2Snmp(tcpstate));
					fclose (in);
					break;

			}/*end of switch(reqoid[9])*/

			/*printf("[TcpFn] nextoid: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d\n", 
			  next_oid[0], next_oid[1], next_oid[2], next_oid[3],
			  next_oid[4], next_oid[5], next_oid[6], next_oid[7],
			  next_oid[8], next_oid[9], next_oid[10], next_oid[11],
			  next_oid[12], next_oid[13], next_oid[14], next_oid[15]);*/
		}


		else { /*interesting else*/
			/* THIS IS THE MOST INTERESTING PART OF THE CODE 
			 * WE ARE DEALING WITH A GETNEXT FOR A COMPLETE OID
			 * THIS MEANS IT CAN BE FROM ANYWHERE WITHIN THE OID TABLE
			 *
			 * r2d3_knail1-> more /proc/net/tcp
			 *   sl  local_address rem_address   st ...
			 *   11: 1A01A8C0:808E 6427EFD8:0050 08  ...
			 *
			 * r2d4_knail1-> snmpwalk r2d3 private tcpConnTable | grep 32913
			 * tcpConnState.192.168.1.26.32913.192.168.1.25.22 = established(5)
			 * tcpConnLocalAddress.192.168.1.26.32913.192.168.1.25.22 = IpAddress: 192.168.1.26
			 * tcpConnLocalPort.192.168.1.26.32913.192.168.1.25.22 = 32913
			 * tcpConnRemAddress.192.168.1.26.32913.192.168.1.25.22 = IpAddress: 192.168.1.25
			 * tcpConnRemPort.192.168.1.26.32913.192.168.1.25.22 = 22
			 */

			/*printf("[TcpFn FullOid] rcvd: %d.%d.%d.%d.%d.%d.%d.%d.%d.%d %d.%d.%d.%d.%d %d.%d.%d.%d.%d: ", 
			  req_oid[0], req_oid[1], 
			  req_oid[2], req_oid[3],
			  req_oid[4], req_oid[5], 
			  req_oid[6], req_oid[7],
			  req_oid[8], req_oid[9],
			  req_oid[10], req_oid[11], 
			  req_oid[12], req_oid[13],
			  req_oid[14], req_oid[15],
			  req_oid[16], req_oid[17],
			  req_oid[18], req_oid[19]); */

			TCPReadFileIntoLL(tcpConnTable_LL, req_oid, oid_length, next_oid, data);	

			fclose (in);

		} /*end of interesting_else */

	} /*end of else if (req_type = snmpgetnext */
	else if (req_type == 3) //snmpset
	{
		sprintf(data, "%d", -1);
		return;
	}

} /*end of TcpFn */



int TCPReadFileIntoLL(tcp_table *global_table, const oid *req_oid, int oid_length, 
		oid *next_oid, char *data)	{
	/*this would read /proc/net/tcp into the passed global tcpConnTable_LL
	 * linked list*/

	char line[300];
	int A,B,C,D,X,P,Q,R,S,Y,tcpstate, lp, rp;
	char la[15], ra[15];
	FILE *in = fopen ("/proc/net/tcp", "r");
	global_table = (tcp_table *)malloc(sizeof(tcp_table));

	if (in == NULL)	{
		perror("TcpFn:TCPReadFileIntoLL: tcpConnTable malloc failed");
		fclose (in);
		return -1;
	}
	if (global_table == NULL) {
		perror("TcpFn:TCPReadFileIntoLL: tcpConnTable malloc failed");
		fclose (in);
		return -1;
	}

	global_table->prev_node = NULL;
	global_table->next_node = NULL;

	while (line == fgets(line, sizeof(line), in)) 
	{
		if (11 != sscanf (line,
					"%*d: %2x%2x%2x%x:%x %2x%2x%2x%x:%x %x %*X:%*X %*X:%*X %*X %*d",
					&D, &C, &B, &A, &X, &S,&R, &Q, &P , &Y, &tcpstate))
			continue; 
		else {
			sprintf(la, "%d.%d.%d.%d", A,B,C,D);
			sprintf(ra, "%d.%d.%d.%d", P,Q,R,S);
			//printf("\n[TCPReadLine..]: local %s:%d\n", la, X); 

			push_tcp(global_table, la, X, ra, Y, tcpstate);
		}
	}


	TCPNextOidCreatorAndDataPopulator(global_table,
			req_oid, oid_length, next_oid, data);
	fclose (in);
	PrintAll(global_table);

	1;
}


int push_tcp(tcp_table *tabul, char *la, int lp, char *ra, int rp, int tcpstate)
{
	/*this fn pushes the newly recieved tcp info into a
	 * ip doubly linked list. note that it assumes that the tcpConnState_LL
	 * has been malloc'ed with its prev_node and next_node set to NULL*/
	tcp_table *current, *new;
	new = (tcp_table *)malloc(sizeof(tcp_table));
	memset(new, 0, sizeof(tcp_table));

	current = tabul;
	while(current->next_node != NULL)
		current = current->next_node;

	current->tcpConnState = Proc2Snmp(tcpstate);
	strcpy(current->LocalAddress, la);
	current->LocalPort = lp;
	strcpy(current->RemoteAddress, ra);
	current->RemotePort = rp;

	/*printf("[push_tcp]: local %s:%d, st%d\n", current->LocalAddress, 
	  current->LocalPort, current->tcpConnState); */

	current->next_node = new;
	current->next_node->next_node = NULL;
	current->next_node->prev_node = current;
	1;
} /*end of push*/



int TCPNextOidCreatorAndDataPopulator(tcp_table *global_table, 
		const oid *req_oid, const int oid_length, 
		oid *next_oid, char *data)
{
	/* the two things of importance to this control block are
	 * (a) req_oid[9] to find out which of the 5 subtrees above and
	 * (b) (local ip:port, and remote ip:port) combination
	 * using the above, it can locate the current position in the tree 
	 * and parse the populated ipNetToMediaTable_LL to retrieve the relevant
	 * data.
	 */
	char localaddress[15], remoteaddress[15];
	int localport, remoteport, tcpstate;

	tcp_table *anchor;
	int comp_val1, comp_val2;

	bzero(data, sizeof(data));


	/*first let's extract all the info from the getnext request */
	sprintf(localaddress, "%d.%d.%d.%d", 
			req_oid[10], req_oid[11], req_oid[12], req_oid[13]);
	sprintf(remoteaddress, "%d.%d.%d.%d", 
			req_oid[15], req_oid[16], req_oid[17], req_oid[18]);

	localport = req_oid[14];
	remoteport = req_oid[19];

	//printf("[TCPNextOidC..] l %s:%d d %s:%d\n", localaddress, localport, remoteaddress, remoteport);

	/*let's also anchor the starting position of the linked list*/
	anchor = global_table;


	switch (req_oid[9])
	{
		case 1:
			/*either the next tcpConnState or the first LocalAddress
			 * needs to be returned*/

			/*iterate until you find the right node in the ll*/
			while (!(((comp_val1 = strcmp(global_table->LocalAddress, localaddress)) == 0) 
						&& ((comp_val2 = strcmp(global_table->RemoteAddress, remoteaddress)) == 0) 
						&& (global_table->LocalPort == localport)
						&& (global_table->RemotePort == remoteport))
					&& (global_table->next_node->next_node != NULL))
			{
				/*printf("[TCPNextOidC..] didnt match, iterate!, %s:%d -- %s:%d \n", 
				  global_table->LocalAddress,
				  global_table->LocalPort,
				  global_table->RemoteAddress,
				  global_table->RemotePort);  */

				global_table = global_table->next_node; 
			}

			/* up until this point, all we have done is find 
			 * our position in the LL based on the req_oid */

			/*printf("[TCPNextOidC..]: Current local %s:%d, rem %s:%d st%d\n", 
			  global_table->LocalAddress, global_table->LocalPort, 
			  global_table->RemoteAddress, global_table->RemotePort,
			  global_table->tcpConnState); */

			if (global_table->next_node->next_node == NULL)	{
				//printf("globaltables next_node is NULL\n");
				/*this means we have reached the last line in proc/net/tcp
				 * or in other words the last line inthe tcpConnState subtree,
				 * so we have to send out the "first" linked lists 
				 * tcpConnLocalAddress, and set oid accordingly*/

				global_table = anchor; /*the first ll*/
				strcpy(data, global_table->LocalAddress);
				/*printf("localaddress : %s/%s, data: %s\n",
				  global_table->LocalAddress,
				  global_table->PhysAddress, data); */

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid, oid_length);
				next_oid[9] = 2;

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);

			} else if ((comp_val2 == 0) 
					&& (comp_val1 == 0)
					&& (global_table->LocalPort == localport)
					&& (global_table->RemotePort == remoteport)
					&& (global_table->next_node->next_node != NULL))
			{
				// printf("[TCPNextOidC..] global_tables next node is not null, but we have a match\n");
				/*this means we matched the tcp leaf, with 
				 * something within the tcpConnStateTable and still haven't
				 * reached the end; thus we need to deliver the next value from
				 * within the SAME subtree (i.e. tcpConnState) */

				global_table = global_table->next_node;


				/*change the /proc/net/tcp's connstate value to 
				 * snmp type (as per RFC1213MIB) */

				sprintf(data, "%d", global_table->tcpConnState);

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid,oid_length);
				/*note that next_oid[9] remains the same here
				  : we are still in the same subtree */

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);
			}
			break;
		case 2:
			/*either the next LocalAddress or the first LocalPort should
			 * be returned*/
			/*iterate until you find the right node in the ll*/
			while (!(((comp_val1 = strcmp(global_table->LocalAddress, localaddress)) == 0) 
						&& ((comp_val2 = strcmp(global_table->RemoteAddress, remoteaddress)) == 0) 
						&& (global_table->LocalPort == localport)
						&& (global_table->RemotePort == remoteport))
					&& (global_table->next_node->next_node != NULL))
			{
				/*printf("didnt match, iterate!, ip/mac in node %s/%s\n", 
				  global_table->LocalAddress,
				  global_table->PhysAddress); */
				global_table = global_table->next_node; 
			}

			if (global_table->next_node->next_node == NULL)	{
				//printf("globaltables next_node is NULL\n");
				/*this means we have reached the last line in proc/net/tcp
				 * or in other words the last line inthe tcpConnLocalAddress subtree,
				 * so we have to send out the "first" linked lists 
				 * tcpConnLocalPort, and set oid accordingly*/

				global_table = anchor; /*the first ll*/

				sprintf(data, "%d", global_table->LocalPort);

				/*printf("localaddress : %s/%s, data: %s\n",
				  global_table->LocalAddress,
				  global_table->PhysAddress, data); */

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid, oid_length);
				next_oid[9] = 3;

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);

			} else if ((comp_val2 == 0) 
					&& (comp_val1 == 0)
					&& (global_table->LocalPort == localport)
					&& (global_table->RemotePort == remoteport)
					&& (global_table->next_node->next_node != NULL))
			{
				//printf("global_tables next node is not null, but we have a match\n");
				/*this means we matched the tcp leaf, with 
				 * something within the tcpConnLocalAddress and still haven't
				 * reached the end; thus we need to deliver the next value from
				 * within the SAME subtree (i.e. tcpLocalAddress) */

				global_table = global_table->next_node;

				strcpy(data, global_table->LocalAddress);

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid,oid_length);
				/*note that next_oid[9] remains the same here
				  : we are still in the same subtree */

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);
			}

			break;
		case 3: 
			/*either the next LocalPort or the first RemoteAddress should be
			 * returned*/
			/*iterate until you find the right node in the ll*/
			while (!(((comp_val1 = strcmp(global_table->LocalAddress, localaddress)) == 0) 
						&& ((comp_val2 = strcmp(global_table->RemoteAddress, remoteaddress)) == 0) 
						&& (global_table->LocalPort == localport)
						&& (global_table->RemotePort == remoteport))
					&& (global_table->next_node->next_node != NULL))
			{
				/*printf("didnt match, iterate!, ip/mac in node %s/%s\n", 
				  global_table->LocalAddress,
				  global_table->PhysAddress); */
				global_table = global_table->next_node; 
			}

			if (global_table->next_node->next_node == NULL)	{
				//printf("globaltables next_node is NULL\n");
				/*this means we have reached the last line in proc/net/tcp
				 * or in other words the last line inthe tcpConnLocalPort subtree,
				 * so we have to send out the "first" linked lists 
				 * tcpConnRemAddress, and set oid accordingly*/

				global_table = anchor; /*the first ll*/

				strcpy(data, global_table->RemoteAddress);

				/*printf("localaddress : %s/%s, data: %s\n",
				  global_table->LocalAddress,
				  global_table->PhysAddress, data); */

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid, oid_length);
				next_oid[9] = 4;

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);

			} else if ((comp_val2 == 0) 
					&& (comp_val1 == 0)
					&& (global_table->LocalPort == localport)
					&& (global_table->RemotePort == remoteport)
					&& (global_table->next_node->next_node != NULL))
			{
				//printf("global_tables next node is not null, but we have a match\n");
				/*this means we matched the tcp leaf, with 
				 * something within the tcpConnLocalPort subtable and still haven't
				 * reached the end; thus we need to deliver the next value from
				 * within the SAME subtree (i.e. tcpConnLocalPort) */

				global_table = global_table->next_node;

				sprintf(data, "%d", global_table->LocalPort);

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid,oid_length);
				/*note that next_oid[9] remains the same here
				  : we are still in the same subtree */

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);
			}
			break;
		case 4: 
			/*either the next RemAddress or the first RemPort should be
			 * returned*/
			/*iterate until you find the right node in the ll*/
			while (!(((comp_val1 = strcmp(global_table->LocalAddress, localaddress)) == 0) 
						&& ((comp_val2 = strcmp(global_table->RemoteAddress, remoteaddress)) == 0) 
						&& (global_table->LocalPort == localport)
						&& (global_table->RemotePort == remoteport))
					&& (global_table->next_node->next_node != NULL))
			{
				/*printf("didnt match, iterate!, ip/mac in node %s/%s\n", 
				  global_table->LocalAddress,
				  global_table->PhysAddress); */
				global_table = global_table->next_node; 
			}

			if (global_table->next_node->next_node == NULL)	{
				//printf("globaltables next_node is NULL\n");
				/*this means we have reached the last line in proc/net/tcp
				 * or in other words the last line inthe RemAddress subtree,
				 * so we have to send out the "first" linked lists 
				 * tcpConnRemPort, and set oid accordingly*/

				global_table = anchor; /*the first ll*/

				sprintf(data, "%d", global_table->RemotePort);

				/*printf("localaddress : %s/%s, data: %s\n",
				  global_table->LocalAddress,
				  global_table->PhysAddress, data); */

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid, oid_length);
				next_oid[9] = 5;

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);

			} else if ((comp_val2 == 0) 
					&& (comp_val1 == 0)
					&& (global_table->LocalPort == localport)
					&& (global_table->RemotePort == remoteport)
					&& (global_table->next_node->next_node != NULL))
			{
				//printf("global_tables next node is not null, but we have a match\n");
				/*this means we matched the tcp leaf, with 
				 * something within the tcpRemAddress subtree and still haven't
				 * reached the end; thus we need to deliver the next value from
				 * within the SAME subtree (i.e. tcpConnRemAddress) */

				global_table = global_table->next_node;

				strcpy(data, global_table->RemoteAddress);

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid,oid_length);
				/*note that next_oid[9] remains the same here
				  : we are still in the same subtree */

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);
			}
			break;
		case 5:
			/*either the next RemPort or -2 (end of tree) should be returned
			*/
			/*iterate until you find the right node in the ll*/
			while (!(((comp_val1 = strcmp(global_table->LocalAddress, localaddress)) == 0) 
						&& ((comp_val2 = strcmp(global_table->RemoteAddress, remoteaddress)) == 0) 
						&& (global_table->LocalPort == localport)
						&& (global_table->RemotePort == remoteport))
					&& (global_table->next_node->next_node != NULL))
			{
				/*printf("didnt match, iterate!, ip/mac in node %s/%s\n", 
				  global_table->LocalAddress,
				  global_table->PhysAddress); */
				global_table = global_table->next_node; 
			}

			if (global_table->next_node->next_node == NULL)	{
				/*this means we have reached the last line in proc/net/tcp
				 * or in other words the last line inthe RemPort subtree,
				 that means end of the whole tree! just return -2 to agent_core
				 no need to mess around with next_oid;*/
				sprintf(data, "%d", -2);

			} else if ((comp_val2 == 0) 
					&& (comp_val1 == 0)
					&& (global_table->LocalPort == localport)
					&& (global_table->RemotePort == remoteport)
					&& (global_table->next_node->next_node != NULL))
			{
				/*this means we matched the tcp leaf with
				 * something within the tcpConnTable and still haven't
				 * reached the end; thus we need to deliver the next value from
				 * within the SAME subtree (ie tcpConnRemPort) */

				global_table = global_table->next_node;
				/*strcpy(global_table->Type, data);*/

				sprintf(data, "%d", global_table->RemotePort);

				NullNextOid(next_oid);
				OidCopier(next_oid, req_oid,oid_length);
				/*note that next_oid[9] remains the same here
				  : we are still in the same subtree */

				PutTcpInNextOid(global_table->LocalAddress,
						global_table->LocalPort,
						global_table->RemoteAddress,
						global_table->RemotePort,
						next_oid);
			}
			break;


		default: /*incorrect OID*/
			sprintf(data, "%d", -1);
			break;
	}
	1;
}

int PutTcpInNextOid(char *la, int lp, char *ra, int rp, oid *next_oid) {
	/*this function takes in la,lp,ra,rp, massages data, and
	 * and sets next_oid[10] through [19] to them. */
	sscanf(la, "%d.%d.%d.%d", &next_oid[10], &next_oid[11],
			&next_oid[12], &next_oid[13]);
	next_oid[14] = lp;
	sscanf(ra, "%d.%d.%d.%d", &next_oid[15], &next_oid[16],
			&next_oid[17], &next_oid[18]);
	next_oid[19] = rp;
	1;
}

int Proc2Snmp(int procstate)	{

	switch (procstate)
	{
		case PROC_TCP_ESTABLISHED:
			return SNMP_TCP_ESTABLISHED;
			break;
		case PROC_TCP_SYN_SENT:
			return SNMP_TCP_SYN_SENT;
			break;
		case PROC_TCP_SYN_RECV:
			return SNMP_TCP_SYN_RECV;
			break;
		case PROC_TCP_FIN_WAIT1:
			return SNMP_TCP_FIN_WAIT1;
			break;
		case PROC_TCP_FIN_WAIT2:
			return SNMP_TCP_FIN_WAIT2;
			break;
		case PROC_TCP_TIME_WAIT:
			return SNMP_TCP_TIME_WAIT;
			break;
		case PROC_TCP_CLOSE:
			return SNMP_TCP_CLOSE;
			break;
		case PROC_TCP_CLOSE_WAIT:
			return SNMP_TCP_CLOSE_WAIT;
			break;
		case PROC_TCP_LAST_ACK:
			return SNMP_TCP_LAST_ACK;
			break;
		case PROC_TCP_LISTEN:
			return SNMP_TCP_LISTEN;
			break;
		case PROC_TCP_CLOSING:
			return SNMP_TCP_CLOSING;
			break;
	} /*end of switch(procstate)*/
}
